RPGITEM = true

PrefabFiles = {
	"magnifyingglass",
	"poison_smoke",
}

STRINGS = GLOBAL.STRINGS
ACTIONS = GLOBAL.ACTIONS

-- [[ magnifying glass ]]

local temprecipe0 = GLOBAL.Recipe( "magnifyingglass", { GLOBAL.Ingredient("goldnugget", 1),  GLOBAL.Ingredient("log", 1) }, GLOBAL.RECIPETABS.TOOLS, {SCIENCE = 1})
temprecipe0.atlas = "images/inventoryimages/magnifyingglass.xml"

STRINGS.NAMES.MAGNIFYINGGLASS = "Magnifying Glass"
STRINGS.RECIPE_DESC.MAGNIFYINGGLASS = "Look really close at strange things."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGNIFYINGGLASS = {}
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MAGNIFYINGGLASS.GENERIC = "An important scientific tool."
STRINGS.CHARACTERS.WX78.DESCRIBE.MAGNIFYINGGLASS = "MAGNIFY"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.MAGNIFYINGGLASS = "Who cares?"
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.MAGNIFYINGGLASS = "I am already wearing glasses..."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.MAGNIFYINGGLASS = "I am detective man!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.MAGNIFYINGGLASS = "With this I am the one who peeks."

local MAGNIFYIDENTIFY = GLOBAL.Action()
MAGNIFYIDENTIFY.str = "Identify"
MAGNIFYIDENTIFY.id = "MAGNIFYIDENTIFY"
MAGNIFYIDENTIFY.fn = function(act)
	if act.target and act.target.components.rpgweapon and act.target.components.rpgweapon.discovered == false and act.invobject and act.invobject.components.magnifyidentify then
		return act.invobject.components.magnifyidentify:DoIdentify(act.target, act.doer)
	end
	if act.target and act.target.components.rpgarmor and act.target.components.rpgarmor.discovered == false and act.invobject and act.invobject.components.magnifyidentify then
		return act.invobject.components.magnifyidentify:DoIdentify(act.target, act.doer)
	end
end

AddAction(MAGNIFYIDENTIFY)

AddStategraphActionHandler("wilson", GLOBAL.ActionHandler(MAGNIFYIDENTIFY, "dolongaction"))

-- [[ effects ]]
STRINGS.RPGITEMS = {}
STRINGS.RPGITEMS.undiscovered = "There's something odd about this...\nI should take a closer look!"

STRINGS.RPGITEMS.WEAPONS = {}

STRINGS.RPGITEMS.WEAPONS.igniter = "Sometimes ignites flammable targets *"
STRINGS.RPGITEMS.WEAPONS.lifesteal = "Steals health from targets on each hit"
STRINGS.RPGITEMS.WEAPONS.freezer = "Sometimes freezes freezable targets *"
STRINGS.RPGITEMS.WEAPONS.shrinker = "Sometimes shrinks and slows targets *"
STRINGS.RPGITEMS.WEAPONS.vorpal = "Very rarely instantly kills targets *"
STRINGS.RPGITEMS.WEAPONS.blessed = "Deals additional damage (20 percent)"
STRINGS.RPGITEMS.WEAPONS.sharp = "Deals additional damage (10 percent)"
STRINGS.RPGITEMS.WEAPONS.teleporter = "Sometimes teleports targets away *"
STRINGS.RPGITEMS.WEAPONS.durable = "Takes longer to break down"
STRINGS.RPGITEMS.WEAPONS.terrifying = "Sometimes causes target to panic *"
STRINGS.RPGITEMS.WEAPONS.poisoning = "Sometimes deals double damage over time *"
STRINGS.RPGITEMS.WEAPONS.slippery = "Can slip out of your hand when used *"
STRINGS.RPGITEMS.WEAPONS.disappearing = "Sometimes vanishes when used *"
STRINGS.RPGITEMS.WEAPONS.thorny = "Deals 1 damage to user when used"
STRINGS.RPGITEMS.WEAPONS.selfrepairing = "Slowly repairs itself over time (always active)"

STRINGS.RPGITEMS.WEAPONS.NAMES = {}
STRINGS.RPGITEMS.WEAPONS.NAMES.igniter = "Flaming"
STRINGS.RPGITEMS.WEAPONS.NAMES.lifesteal = "Leeching"
STRINGS.RPGITEMS.WEAPONS.NAMES.freezer = "Freezing"
STRINGS.RPGITEMS.WEAPONS.NAMES.shrinker = "Minimizing"
STRINGS.RPGITEMS.WEAPONS.NAMES.vorpal = "Vorpal"
STRINGS.RPGITEMS.WEAPONS.NAMES.blessed = "Blessed"
STRINGS.RPGITEMS.WEAPONS.NAMES.sharp = "Well-crafted"
STRINGS.RPGITEMS.WEAPONS.NAMES.teleporter = "Telelocating"
STRINGS.RPGITEMS.WEAPONS.NAMES.durable = "Sturdy"
STRINGS.RPGITEMS.WEAPONS.NAMES.terrifying = "Terrifying"
STRINGS.RPGITEMS.WEAPONS.NAMES.poisoning = "Poisonous"
STRINGS.RPGITEMS.WEAPONS.NAMES.slippery = "Slippery"
STRINGS.RPGITEMS.WEAPONS.NAMES.disappearing = "Disappearing"
STRINGS.RPGITEMS.WEAPONS.NAMES.thorny = "Thorny"
STRINGS.RPGITEMS.WEAPONS.NAMES.selfrepairing = "Self-repairing"

STRINGS.RPGITEMS.ARMOR = {}

STRINGS.RPGITEMS.ARMOR.NAMES = {}
STRINGS.RPGITEMS.ARMOR.NAMES.durable = "Sturdy"
STRINGS.RPGITEMS.ARMOR.NAMES.fireproof = "Fireproof"
STRINGS.RPGITEMS.ARMOR.NAMES.cozy = "Cozy"
STRINGS.RPGITEMS.ARMOR.NAMES.dapperness = "Dapper"
STRINGS.RPGITEMS.ARMOR.NAMES.selfrepairing = "Self-repairing"
STRINGS.RPGITEMS.ARMOR.NAMES.healing = "Healing"
STRINGS.RPGITEMS.ARMOR.NAMES.fasting = "Faster's"
STRINGS.RPGITEMS.ARMOR.NAMES.hungry = "Hungry"
STRINGS.RPGITEMS.ARMOR.NAMES.traveller = "Quick"
STRINGS.RPGITEMS.ARMOR.NAMES.slowpoke = "Heavy"
STRINGS.RPGITEMS.ARMOR.NAMES.brilliant = "Sentient"
STRINGS.RPGITEMS.ARMOR.NAMES.insomniac = "Tickling"
STRINGS.RPGITEMS.ARMOR.NAMES.entombing = "Entombing"
STRINGS.RPGITEMS.ARMOR.NAMES.telelocating = "Wish-away"

STRINGS.RPGITEMS.ARMOR.durable = "Takes longer to break down"
STRINGS.RPGITEMS.ARMOR.fireproof = "Reduces fire-damage by a third"
STRINGS.RPGITEMS.ARMOR.cozy = "Small protection against freezing"
STRINGS.RPGITEMS.ARMOR.dapperness = "Small bonus to sanity"
STRINGS.RPGITEMS.ARMOR.selfrepairing = "Slowly repairs itself over time (always active)"
STRINGS.RPGITEMS.ARMOR.healing = "Slowly heals wearer over time"
STRINGS.RPGITEMS.ARMOR.fasting = "Reduces hunger drain"
STRINGS.RPGITEMS.ARMOR.hungry = "Increases hunger drain"
STRINGS.RPGITEMS.ARMOR.traveller = "Increases speed"
STRINGS.RPGITEMS.ARMOR.slowpoke = "Decreases speed"
STRINGS.RPGITEMS.ARMOR.brilliant = "Helps wearer understand Science"
STRINGS.RPGITEMS.ARMOR.insomniac = "Prevents sleeping"
STRINGS.RPGITEMS.ARMOR.entombing = "Sometimes freezes attacker if struck *"
STRINGS.RPGITEMS.ARMOR.telelocating = "Sometimes teleports attackers away *"

function HF_addrpgweapon(inst)
	inst:AddComponent("rpgweapon")
end

AddPrefabPostInit("axe", HF_addrpgweapon)
AddPrefabPostInit("goldenaxe", HF_addrpgweapon)
AddPrefabPostInit("hambat", HF_addrpgweapon)
AddPrefabPostInit("spear", HF_addrpgweapon)
AddPrefabPostInit("tentaclespike", HF_addrpgweapon)
AddPrefabPostInit("nightsword", HF_addrpgweapon)
AddPrefabPostInit("pickaxe", HF_addrpgweapon)
AddPrefabPostInit("goldenpickaxe", HF_addrpgweapon)
AddPrefabPostInit("fishingrod", HF_addrpgweapon)
AddPrefabPostInit("bugnet", HF_addrpgweapon)
AddPrefabPostInit("hammer", HF_addrpgweapon)
AddPrefabPostInit("shovel", HF_addrpgweapon)
AddPrefabPostInit("goldenshovel", HF_addrpgweapon)
AddPrefabPostInit("pitchfork", HF_addrpgweapon)
AddPrefabPostInit("cane", HF_addrpgweapon)
AddPrefabPostInit("batbat", HF_addrpgweapon)
AddPrefabPostInit("multitool_axe_pickaxe", HF_addrpgweapon)
AddPrefabPostInit("ruins_bat", HF_addrpgweapon)
-- DLC
AddPrefabPostInit("spear_wathgrithr", HF_addrpgweapon)

function HF_addrpgarmor(inst)
	inst:AddComponent("rpgarmor")
end
AddPrefabPostInit("armorgrass", HF_addrpgarmor)
AddPrefabPostInit("armor_sanity", HF_addrpgarmor)
AddPrefabPostInit("umbrella", HF_addrpgarmor)
AddPrefabPostInit("torch", HF_addrpgarmor)
AddPrefabPostInit("armorwood", HF_addrpgarmor)
AddPrefabPostInit("armormarble", HF_addrpgarmor)
AddPrefabPostInit("sweatervest", HF_addrpgarmor)
AddPrefabPostInit("trunkvest_summer", HF_addrpgarmor)
AddPrefabPostInit("trunkvest_winter", HF_addrpgarmor)
AddPrefabPostInit("armorsnurtleshell", HF_addrpgarmor)
AddPrefabPostInit("nightlight", HF_addrpgarmor)
AddPrefabPostInit("armorruins", HF_addrpgarmor)
AddPrefabPostInit("armorslurper", HF_addrpgarmor)
AddPrefabPostInit("earmuffshat", HF_addrpgarmor)
AddPrefabPostInit("tophat", HF_addrpgarmor)
AddPrefabPostInit("beefalohat", HF_addrpgarmor)
AddPrefabPostInit("featherhat", HF_addrpgarmor)
AddPrefabPostInit("beehat", HF_addrpgarmor)
AddPrefabPostInit("minerhat", HF_addrpgarmor)
AddPrefabPostInit("spiderhat", HF_addrpgarmor)
AddPrefabPostInit("footballhat", HF_addrpgarmor)
AddPrefabPostInit("winterhat", HF_addrpgarmor)
AddPrefabPostInit("walrushat", HF_addrpgarmor)
AddPrefabPostInit("slurtlehat", HF_addrpgarmor)
AddPrefabPostInit("ruinshat", HF_addrpgarmor)
-- DLC
AddPrefabPostInit("wathgrithrhat", HF_addrpgarmor)
AddPrefabPostInit("icehat", HF_addrpgarmor)
AddPrefabPostInit("rainhat", HF_addrpgarmor)
AddPrefabPostInit("catcoonhat", HF_addrpgarmor)
AddPrefabPostInit("watermelonhat", HF_addrpgarmor)
AddPrefabPostInit("grass_umbrella", HF_addrpgarmor)


-- add our text so when an item is examined it shows up if needed
function rpgweaponinspectable(inst)
	local oldGetDescription = inst.GetDescription
	inst.GetDescription = function (self, viewer)
		local oldtext = oldGetDescription(self, viewer)
		if self.inst.components.rpgweapon and self.inst.components.rpgweapon:ReturnString() ~=nil then
			local returntext = self.inst.components.rpgweapon:ReturnString()
			if viewer.prefab == "wx78" then
				returntext = string.upper(returntext)
			end
			if viewer.prefab == "wes" then
				returntext = ""
			end
			return oldtext .. returntext
		elseif self.inst.components.rpgarmor and self.inst.components.rpgarmor:ReturnString() ~=nil then
			local returntext = self.inst.components.rpgarmor:ReturnString()
			if viewer.prefab == "wx78" then
				returntext = string.upper(returntext)
			end
			if viewer.prefab == "wes" then
				returntext = ""
			end
			return oldtext .. returntext
		else
			return oldtext 
		end

	end
end
AddComponentPostInit("inspectable", rpgweaponinspectable)

